#ifndef _ZONEREPRESENTATION_H__
#define _ZONEREPRESENTATION_H__

#pragma once

#include <vector>
//#include "DLPoint.h"
#include "DLLineShape.h"

using namespace std;

class CZoneRepresentation
{
private:
	vector <DLLineShape> vLines;		//vector of voronoi lines covering the zone
	vector <DLLineShape> pLines;		//vector of polygon edges covering the zone

public:
	CZoneRepresentation();
	~CZoneRepresentation(void);

	void addVLine(DLLineShape ls);
	void addPLine(DLLineShape ls);

	DLLineShape getVLine(int i);
	DLLineShape getPLine(int i);
};

#endif