$inputFile = $ARGV[0];


print "Working on $inputFile file\n";

$tiffFile = $inputFile;
$tiffFile =~ s/txt/tif/;

open(IN, $inputFile) || die("Could not open input txt file");

$outputFile = $inputFile;

$outputFile =~ s/txt/xml/;

open(OUT, ">$outputFile") || die("Could not open output xml file");

print OUT "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<!--GEDI is developed at Language and Media Processing Laboratory, University of Maryland.-->
<GEDI xmlns=\"http://lamp.cfar.umd.edu/GEDI\" version=\"1.0\">
<USER name=\"Mudit\" date=\"4/28/2008 21:39\" dateFormat=\"mm/dd/yyyy hh:mm\">	</USER>
<DL_DOCUMENT src=\"$tiffFile\" docTag=\"xml\" NrOfPages=\"1\">
<DL_PAGE gedi_type=\"DL_PAGE\" src=\"$tiffFile\" pageID=\"1\">
";
$count = 1;
foreach $line (<IN>)
{
	$line =~ /(\d+) (\d+) (\d+) (\d+)/; 
	print OUT "<DL_ZONE gedi_type=\"MARKUP\" id=\"$count\" col=\"$1\" row=\"$3\" width=\"1\" height=\"1\" polygon=\"($1,$3);($2,$4)\" zoneType=\"text-body\" contents=\"\" />\n";

	$count = $count + 1;
}

print OUT "
  </DL_PAGE>
  </DL_DOCUMENT>
  </GEDI>
  ";

close(IN);
close(OUT);
