static char version_string[]="$Id: cline.c,v 1.3 1999/10/15 12:36:21 kise Exp $";
/*
   $Date: 1999/10/15 12:36:21 $
   $Revision: 1.3 $
   $Author: kise $

   cline.c
   $B0z?t$N2r@O(B  analysis of arguments
*/
#include <stdio.h>
#include <stdlib.h>
#include "const.h"
#include "extern.h"
#include "function.h"

void analyze_cline(char **argv, int *ifargc, int *ofargc)
{
  int i = 1;
  int j = 0;
  int argc_tmp[2];

  while( argv[i] != NULL) {
    if(strcmp(argv[i],"-sr")==0) {
      i++;
      if(argv[i] == NULL) usage();
      sample_rate = atoi(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-nm")==0) {
      i++;
      if(argv[i] == NULL) usage();
      noise_max = atoi(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-fr")==0) {
      i++;
      if(argv[i] == NULL) usage();
      freq_rate = atof(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-ta")==0) {
      i++;
      if(argv[i] == NULL) usage();
      t_area = atof(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-td")==0) {
      i++;
      if(argv[i] == NULL) usage();
      t_dia = atof(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-af")==0) {
      i++;
      if(argv[i] == NULL) usage();
      angle_filter = atof(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-df")==0) {
      i++;
      if(argv[i] == NULL) usage();
      dist_filter = atof(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-sw")==0) {
      i++;
      if(argv[i] == NULL) usage();
      smwind = atoi(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-ct")==0) {
      i++;
      if(argv[i] == NULL) usage();
      c_theta = atof(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-cd")==0) {
      i++;
      if(argv[i] == NULL) usage();
      c_dist = atof(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-loop")==0) {
      i++;
      if(argv[i] == NULL) usage();
      looptimes = atoi(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-apt")==0) {
      i++;
      if(argv[i] == NULL) usage();
      aptnbr = atoi(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-minnoe")==0) {
      i++;
      if(argv[i] == NULL) usage();
      minnoe = atoi(argv[i]);
      i++;
    }
    else if(strcmp(argv[i],"-autocd")==0) {
      cdist_is_auto = YES;
      i++;
    }
    else if(strcmp(argv[i],"-och")==0) {
      output_convexhull = YES;
      i++;
    }
    else if(strcmp(argv[i],"-ichl")==0) {
      in_ch_line = YES;
      i++;
    }
    else if(strcmp(argv[i],"-points")==0) {
      output_points = YES;
      i++;
    }
    else if(strcmp(argv[i],"-pvor")==0) {
      output_pvor = YES;
      i++;
    }
    else if(strcmp(argv[i],"-avor")==0) {
      output_avor = YES;
      i++;
    }
    else if(strcmp(argv[i],"-ng")==0) {
      output_ng = YES;
      i++;
    }
    else if(strcmp(argv[i],"-seed")==0) {
      output_seed = YES;
      i++;
    }
    else if(strcmp(argv[i],"-dparam")==0) {
      display_parameters = YES;
      i++;
    }
    else {
      argc_tmp[j] = i;
      j++;
      i++;
    }
  }

  if( j != 2 ) usage();
  else {
    *ifargc = argc_tmp[0];
    *ofargc = argc_tmp[1];
  }
}
