#!/usr/bin/perl

$inputFile = $ARGV[0];

print "Input file is $inputFile\n";

open(LIST, $inputFile) || die("Could not open input file $inputFile");

print "Working on $inputFile file\n";

while(<LIST>)
{

	$txtFile = $_;
	$txtFile =~ s/\..*/\.txt/;

	open(IN, $txtFile) || die("Could not open input txt file");

	$outFile = $txtFile;
	$outFile =~ s/\.txt/_coords\.txt/;

	print "Input File: $txtFile\n Output File: $outFile\n\n";

	open(OUT, ">$outFile") || die("Could not open output file");

	while(<IN>)
	{
		/(\d+) (\d+) (\d+) (\d+)/;
		print OUT "$1 $3 $2 $4\n";
		
	}

	close(IN);
	close(OUT);
}

close(IN);
close(LIST);
