static char version_string[]="$Id: component.c,v 1.2 1999/10/07 11:54:00 kise Exp $";
/*
   $Date: 1999/10/07 11:54:00 $
   $Revision: 1.2 $
   $Author: kise $

   component.c
   Component component ͤ򥻥åȤ뤿δؿ set_componet 
   --------------------------------------------------------------------
   Program component.c
   This program is to set data of the Component type.
*/

#include <stdio.h>
#include <stdlib.h>
#include "defs.h"
#include "const.h"
#include "extern.h"
#include "function.h"


void set_component(Coordinate max_x, Coordinate max_y)
{
  Coordinate *xmin,*xmax,*ymin,*ymax;
  NumPixel k;
  
  /* ΰ */
  xmin = (Coordinate *)myalloc(sizeof(unsigned short)*(LABELnbr));
  xmax = (Coordinate *)myalloc(sizeof(unsigned short)*(LABELnbr));
  ymin = (Coordinate *)myalloc(sizeof(unsigned short)*(LABELnbr));
  ymax = (Coordinate *)myalloc(sizeof(unsigned short)*(LABELnbr));

  /*  */
  for(k=0;k<LABELnbr;k++){
    xmin[k]=max_x;
    xmax[k]=0;
    ymin[k]=max_y;
    ymax[k]=0;
  }
  
  for(k=0;k<BPnbr;k++){

    if(bpx[k].xax < xmin[bpx[k].label]){
      xmin[bpx[k].label] = bpx[k].xax;
    }
    if(bpx[k].xax > xmax[bpx[k].label]){
      xmax[bpx[k].label] = bpx[k].xax;
    }
    if(bpx[k].yax < ymin[bpx[k].label]){
      ymin[bpx[k].label] = bpx[k].yax;
    }
    if(bpx[k].yax > ymax[bpx[k].label]){
      ymax[bpx[k].label] = bpx[k].yax;
    }

  }
    
  for(k=0;k<LABELnbr;k++){
    component[k].xc = (xmin[k]+xmax[k])/2;
    component[k].yc = (ymin[k]+ymax[k])/2;
  }
  /* debug */
  /*  for(k=0;k<LABELnbr;k++){
      fprintf(stderr,"%d %d %d %d\n",xmin[k],xmax[k],ymin[k],ymax[k]);
      }*/
  
  /* ΰ */
  free(xmin);
  free(xmax);
  free(ymin);
  free(ymax);
}
