static char version_string[]="$Id: dinfo.c,v 1.1.1.1 1999/10/07 07:09:00 kise Exp $";
/*
   $Date: 1999/10/07 07:09:00 $
   $Revision: 1.1.1.1 $
   $Author: kise $
   dinfo.c
*/
#include <stdio.h>
#include "extern.h"

void dparam()
{
  fprintf(stderr,"Parameters : \n");
  fprintf(stderr,
	  "\tsampling rate\t%d\n",sample_rate);
  fprintf(stderr,
	  "\tnoise max\t%d\n",noise_max);
  fprintf(stderr,"\tfreq_rate\t%f\n",freq_rate);
  fprintf(stderr,"\tsmwind\t\t%d\n",smwind);
  fprintf(stderr,"\tt_area\t\t%f\n",t_area);
  fprintf(stderr,"\tt_dia\t\t%f\n",t_dia);
  fprintf(stderr,"\tangle_filter\t%f\n",angle_filter);
  fprintf(stderr,"\tdist_filter\t%f\n",dist_filter);
  fprintf(stderr,"\tc_theta\t\t%f\n",c_theta);
  fprintf(stderr,"\tc_dist\t\t%f\n",c_dist);
  fprintf(stderr,"\tlooptimes\t%d\n",looptimes);
  fprintf(stderr,"\taptnbr\t\t%d\n",aptnbr);
  fprintf(stderr,"\tminnoe\t\t%d\n",minnoe);
}

void dnumber(int imax, int jmax)
{
  fprintf(stderr,"---------------------------------------------------------\n");
  fprintf(stderr,"image size \t\t\t\t\t%d x %d\n",imax,jmax);
  fprintf(stderr,"black pixels\t\t\t\t\t%d\n",BPnbr);
  fprintf(stderr,"connected components\t\t\t\t%d\n",LABELnbr);
  fprintf(stderr,"sample points\t\t\t\t\t%d\n",sample_pix);
  fprintf(stderr,"point Voronoi line segments\t\t\t%d\n",point_edge);
  fprintf(stderr,"edges in the neighbor graph (before selection)\t%d\n",NEIGHnbr);
  fprintf(stderr,"edges in the neighbor graph (after selection)\t%d\n",edge_nbr);
  fprintf(stderr,"---------------------------------------------------------\n");
}

#ifdef TIME
void dtime()
{
  fprintf(stderr,"\tlabeling\tconvex hull\tvoronoi\t\terase\toutput\tetc\n");
  fprintf(stderr,"Time\t%.3f\t\t%.3f\t\t%.3f\t\t%.3f\t%.3f\t%.3f\n",
	  b_s_time-c_time,c_time,v_time,e_time,o_time,etc_time);
}
#endif
