/*
   $Id: extern.h,v 1.4 1999/10/15 01:36:54 kise Exp $
   $Date: 1999/10/15 01:36:54 $
   $Revision: 1.4 $
   $Author: kise $
*/
#include <stdio.h>
#include "defs.h"

extern float	                xmin;
extern float	                xmax;
extern float	                ymin;
extern float	                ymax;
extern float	                deltax;
extern float	                deltay;

extern struct	Site	        *sites;
extern int			nsites;
extern int			siteidx;
extern int			sqrt_nsites;
extern int			nvertices;
extern struct 	Freelist 	sfl;
extern struct	Site		*bottomsite;

extern int 			nedges;
extern struct	Freelist 	efl;

extern struct   Freelist	hfl;
extern struct	Halfedge	*ELleftend, *ELrightend;
extern int 			ELhashsize;
extern struct	Halfedge	**ELhash;

extern int 			PQhashsize;
extern struct	Halfedge 	*PQhash;
extern int 			PQcount;
extern int 			PQmin;

extern Component                *component;
extern BlackPixel               *bpx;
extern Neighborhood	        *neighbor;
extern LineSegment	        *lineseg;
extern EndPoint		        *endp;
extern HashTable	        *hashtable[M1+M2];

extern NumPixel                 BPnbr;
extern Label                    LABELnbr;
extern unsigned int	        NEIGHnbr;
extern unsigned int	        LINEnbr;
extern unsigned int             sample_pix;
extern unsigned int             point_edge;
extern unsigned int             edge_nbr;
extern long		        SiteMax;

extern int                      sample_rate;
extern int                      noise_max;
extern float                    freq_rate;
extern float                    t_area;
extern float                    t_dia;
extern float                    angle_filter;
extern float                    dist_filter;
extern int                      smwind;
extern float                    c_theta;
extern float                    c_dist;
extern int                      looptimes;
extern int                      aptnbr;
extern int                      minnoe;
extern char                     cdist_is_auto;
extern char                     output_convexhull;
extern char                     in_ch_line;
extern char                     output_points;
extern char                     output_pvor;
extern char                     output_avor;
extern char                     output_ng;
extern char                     output_seed;
extern char                     display_parameters;

#ifdef TIME
extern float b_s_time;
extern float c_time;
extern float v_time;
extern float e_time;
extern float o_time;
extern float etc_time;
#endif

extern FILE                     *ofp;
