static char version_string[]="$Id: sampling_points.c,v 1.4 1999/10/15 12:36:21 kise Exp $";
/***************************************************************************
*   $Date: 1999/10/15 12:36:21 $                                           *
*   $Revision: 1.4 $                                                       *
*   $Author: kise $                                                        *
*                                                                          *
*   sampling_points.c                                                      *
*   ϢʬɽץΥꥹȤ                             *
*   sampling points on the contours of connected components                *
***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "const.h"
#include "defs.h"
#include "extern.h"
#include "function.h"


List2 **sampling_points; /* Ϣʬ饵ץ󥰤줿ؤб */

/*
 *  init_sampling_points
 *  sampling_points ؿ
 */
int init_sampling_points()
{
  int i;
	
  sampling_points = (List2 **)myalloc(sizeof(List2*) * LABELnbr);

  /* sampling_points  */
  for(i=0;i<LABELnbr;i++){
    sampling_points[i] = NULL;
  }

  return 0;
}

/* 
 *  set_sampling_points
 *  sampling_points 򥻥åȤؿ
 */
int set_sampling_points(Label label, float x, float y)
{
  List2 *new_element;

  new_element = (List2 *)myalloc(sizeof(List2));

  new_element->coord.x = x;
  new_element->coord.y = y;
  new_element->next = sampling_points[label];
  sampling_points[label] = new_element;
	
  return 0;
}

/*
 *  get_sampling_points
 *  sampling_points ΥǡФؿ
 */
List2* get_sampling_points(Label label)
{
  return sampling_points[label];
}

/*
 *  print_sp
 *  ǥХåѴؿ
 */
/*
void print_sp()
{
  int   i;
  List2 *read;

  for(i = 0; i < LABELnbr; i++){
    fprintf(stderr, "label  %d\n", i);
    read = sampling_points[i];

    while(read != NULL){
      fprintf(stderr, "%f %f\n", read->coord.x, read->coord.y);
      read = read->next;
    }
  }
}
*/
