static char version_string[]="$Id: usage.c,v 1.2 1999/10/07 11:54:01 kise Exp $";
/*
  $Date: 1999/10/07 11:54:01 $
  $Revision: 1.2 $
  $Author: kise $
 */
#include <stdio.h>
#include "const.h"

void usage()
{
  fprintf(stderr,"\nUsage : le ");
  fprintf(stderr,"<input_file> <output_file>\n");
  fprintf(stderr," input_file  : a binary doc. image (sun raster or tiff format)\n");
  fprintf(stderr," output_file : line segments or points (ascii)\n");
  fprintf(stderr," options : [-<argument> (<data type>)] : <meaning>:<<default value>>\n");
  fprintf(stderr," [-sr (int)]    : sampling rate                                        :<%d>\n",
	  SAMPLE_RATE);
  fprintf(stderr," [-nm (int)]    : max size (area) of noise CC                          :<%d>\n",
	  NOISE_MAX);
  fprintf(stderr," [-af (float)]  : threshold value for the variance of angles           :<%.1f>\n",
	  ANGLE_FILTER);
  fprintf(stderr," [-df (float)]  : threshold value for the variance of distance         :<%.1f>\n",
	  DIST_FILTER);
  fprintf(stderr," [-sw (int)]    : size of smoothing window of distance                 :<%d>\n",
	  SMWIND);
  fprintf(stderr," [-loop (int)]  : the number of iteration for extending seeds          :<%d>\n",
	  LOOPTIMES);
  fprintf(stderr," [-apt (int)]   : the number of candidates for extending seeds         :<%d>\n",
	  APTNBR);
  fprintf(stderr," [-ta (float)]  : threshold value for area ratio                       :<%.3f>\n",
	  T_AREA);
  fprintf(stderr," [-td (float)]  : threshold value for diameter ratio                   :<%.3f>\n",
	  T_DIA);
  fprintf(stderr," [-ct (float)]  : angle parameter for extending seeds                  :<%.1f>\n",
	  (float)C_THETA);
  fprintf(stderr," [-cd (float)]  : distance parameter for extending seeds               :<%.1f>\n",
	  (float)C_DIST);
  fprintf(stderr," [-minnoe (int)]: the min. number of edges in a text-line              :<%d>\n",
	  MINNOE);
  fprintf(stderr," [-dparam]      : display parameters                                   :<NO>\n");
  fprintf(stderr," [-och]         : output is convex hulls of text-lines                 :<NO>\n");
  fprintf(stderr," [-ichl]        : output is edges in convex hulls of text-lines        :<NO>\n");
  fprintf(stderr," [-points]      : output is points on boundaries of CC's               :<NO>\n");
  fprintf(stderr," [-pvor]        : output is Voronoi edges of the point Voronoi diagram :<NO>\n");
  fprintf(stderr," [-avor]        : output is Voronoi edges of the area Voronoi diagram  :<NO>\n");
  fprintf(stderr," [-ng]          : output is the neighbor graph                         :<NO>\n");
  fprintf(stderr," [-seed]        : output is seeds                                      :<NO>\n");
  exit(-1);
}






